Bug 1577508 - gcov-8 warns about 'arcs to entry block' for each function of votca-tools
Summary: gcov-8 warns about 'arcs to entry block' for each function of votca-tools
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: gcc
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-05-12 15:28 UTC by Christoph Junghans
Modified: 2019-05-28 22:34 UTC (History)
12 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-05-28 22:34:55 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github laristra flecsi issues 415 0 None None None Never
Github votca votca issues 67 0 None None None Never

Description Christoph Junghans 2018-05-12 15:28:28 UTC
Description of problem:

When using gcov-8 on f28, I get a warning like:
./tools/src/libtools/CMakeFiles/votca_tools.dir/graphnode.cc.gcno:'_ZdlPvS_' has arcs to entry block
./tools/src/libtools/CMakeFiles/votca_tools.dir/graphnode.cc.gcno:'_ZdlPvS_' has arcs from exit block

for each function. Usually that happens when g++ and gcov are different versions, but that isn't the case here.


Version-Release number of selected component (if applicable):
gcc --version
gcc (GCC) 8.1.1 20180502 (Red Hat 8.1.1-1)
gcov --version
gcov (GCC) 8.1.1 20180502 (Red Hat 8.1.1-1)


How reproducible:
I used the f28 and f27 docker container to ensure this is not my system, which got updated many times since installed with f23.


Steps to Reproduce:
1. dnf install 'dnf-command(builddep)'
2. dnf builddep votca-tools
3. dnf install git make gcc-c++ findutils
4. git clone --recursive --depth 1 https://github.com/votca/votca
5. cd votca
6. mkdir build
7. cd build
8. cmake -DWITH_GMX=OFF -DENABLE_TESTING=ON -DENABLE_COVERAGE_BUILD=ON ..
9. make votca_property
10. ctest -R votca_property
11. find . -name "*.gcda" -exec gcov {} +


Actual results:
No warning - is the case on f27

Expected results:
1000s of 'arcs to entry block' and 'arcs to exit block' warning - is the case on f28

Additional info:

Comment 1 Christoph Junghans 2018-05-17 21:49:10 UTC
And I think, I mixed up expected and actual results.

Comment 2 Rian Quinn 2018-09-23 13:52:08 UTC
Was this ever fixed? I am seeing the same issue with GCC 8. GCC 6 seems to turn off support for C++17, so at the moment, attempting to get a coverage report from GCC seems to be limited to GCC 7 if you want C++17 support.

Comment 3 Jonathan Wakely 2018-09-24 09:29:09 UTC
What do you mean "turn off support for C++17"?

GCC 6 was released in 2016 so obviously its support for C++17 is limited, but it doesn't turn anything off.

Comment 4 Rian Quinn 2018-09-24 11:13:40 UTC
When I enabled coverage support in GCC 6, it complains about nested namespaces and maybe_unused, as if they are not a thing (almost like it turned off support for C++17). Works fine with GCC 6 so long as I don't turn on coverage. Whatever the issue is, it was addressed in GCC 7 as it works fine. 

Here is an example of what I am talking about:
https://travis-ci.org/Bareflank/hypervisor/jobs/432120401

Here is an example of the GCC 8 issue:
https://travis-ci.org/Bareflank/hypervisor/jobs/432130712


- Rian

Comment 5 Jonathan Wakely 2018-09-24 11:32:20 UTC
(In reply to Rian Quinn from comment #4)
> Here is an example of what I am talking about:
> https://travis-ci.org/Bareflank/hypervisor/jobs/432120401

That complains about this syntax:

/home/travis/build/Bareflank/hypervisor/bfvmm/src/memory_manager/memory_manager.cpp:395:43: error: expected ‘)’ before ‘;’ token
     if (auto iter = m_virt_map.find(upper); iter != m_virt_map.end()) {
                                           ^

And that's because GCC 6.4 doesn't support that C++17 feature, at all, with or without coverage enabled.

Comment 6 Rian Quinn 2018-09-24 18:27:07 UTC
Huh.... your right. I could have sworn we had it compiling with 6 without coverage, but we don't, its only set up for 7 and above. Well, that explains that specific issue. Doesn't solve the issue with 8 though.

Comment 7 Jonathan Wakely 2018-09-25 10:24:28 UTC
Christoph's original report doesn't seem to be related to C++17, as votca-tools builds with -std=c++11 and still produces these warnings.

Comment 8 Christoph Junghans 2018-09-25 12:42:04 UTC
(In reply to Jonathan Wakely from comment #7)
> Christoph's original report doesn't seem to be related to C++17, as
> votca-tools builds with -std=c++11 and still produces these warnings.

That is correct, I saw it for a bunch of C++11 builds, e.g. votca-tools, votca-csg, espresso++, flecsi.

Comment 9 Rian Quinn 2018-09-25 16:05:11 UTC
We are only using C++17, but I would agree that this is likely not related to C++17 at all.

Comment 10 Ben Cotton 2019-05-02 20:50:42 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 11 Ben Cotton 2019-05-28 22:34:55 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.